/**
 * NOTE: This class is auto generated by the swagger code generator program (3.0.32).
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */
package nl.vng.vacatures_bron.controller;


import nl.vng.vacatures_bron.exception.MismatchCertWithOinVumProviderException;
import nl.vng.vacatures_bron.config.ConfigProperties;
import nl.vng.vacatures_bron.dto.InlineResponse200;
import nl.vng.vacatures_bron.dto.VacatureMatchesRequest;
import nl.vng.vacatures_bron.dto.VacatureMatchingProfielen;
import nl.vng.vacatures_bron.entity.Vacature;
import nl.vng.vacatures_bron.exception.VacatureNotFoundException;
import nl.vng.vacatures_bron.service.ElkService;
import nl.vng.vacatures_bron.service.VumService;
import io.swagger.v3.oas.annotations.Hidden;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.enums.ParameterIn;
import io.swagger.v3.oas.annotations.media.Content;
import io.swagger.v3.oas.annotations.media.Schema;
import io.swagger.v3.oas.annotations.responses.ApiResponse;
import io.swagger.v3.oas.annotations.responses.ApiResponses;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.tuple.ImmutablePair;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import javax.validation.constraints.Pattern;
import java.util.Optional;


@Validated
@Hidden
@Controller
@Slf4j
@CrossOrigin()
public class VumController {

	public static final String X_VUM_BERICHT_VERSIE = "X-VUM-berichtVersie";
    public static final String X_VUM_FROM_PARTY = "X-VUM-fromParty";
    public static final String X_VUM_VIA_PARTY = "X-VUM-viaParty";
    public static final String X_VUM_TO_PARTY = "X-VUM-toParty";
    public static final String X_VUM_SUWIPARTY = "X-VUM-SUWIparty";
    public static final String X_FORWARDED_FOR = "X-Forwarded-For";

    private final VumService vumService;

    private final ElkService elkService;
    
    private final ConfigProperties config;

    @Autowired
    public VumController(final VumService vum, final ElkService elk, final ConfigProperties configProperties) {
        this.vumService = vum;
        this.elkService = elk;
        this.config = configProperties;
    }

    /**
     * GET /vacatures/{idVacature} : Vraag detailvacatures op bij opgegeven idVacature
     * Vraag detailprofielen op bij een opgegeven idVacature
     *
     * @param idVacature        (required)
     * @param xVUMBerichtVersie (required)
     * @param xVUMFromParty     (required)
     * @param xVUMToParty       (required)
     * @param xVUMSUWIparty     (required)
     * @param xVUMViaParty      (optional)
     * @return OK (status code 200)
     * or Bad request (status code 400)
     * or not authorized (status code 401)
     * or Too Many Requests, limiet is overschreden voor deze uitvraag (status code 429)
     * or Internal Server Error (status code 500)
     * or Service Unavailable (status code 503)
     */
    @Operation(summary = "Vraag volledige vacature op bij opgegeven idVacature", description = "Vraag volledige vacature op bij een opgegeven idVacature", tags = {})
    @ApiResponses(value = {
            @ApiResponse(responseCode = "200", description = "OK", content = @Content(mediaType = "application/json", schema = @Schema(implementation = Vacature.class))),
            @ApiResponse(responseCode = "400", description = "Bad request", content = @Content(mediaType = "application/json", schema = @Schema(implementation = Error.class))),
            @ApiResponse(responseCode = "401", description = "not authorized"),
            @ApiResponse(responseCode = "429", description = "Too Many Requests, limiet is overschreden voor deze uitvraag", content = @Content(mediaType = "application/json", schema = @Schema(implementation = Error.class))),
            @ApiResponse(responseCode = "500", description = "Internal Server Error", content = @Content(mediaType = "application/json", schema = @Schema(implementation = Error.class))),
            @ApiResponse(responseCode = "503", description = "Service Unavailable", content = @Content(mediaType = "application/json", schema = @Schema(implementation = Error.class)))})
    @GetMapping(
            value = "/vacatures/{idVacature}",
            produces = {"application/json"}
    )
    public ResponseEntity<Vacature> getVacature(@Parameter(in = ParameterIn.PATH, description = "", required = true, schema = @Schema()) @PathVariable("idVacature") String idVacature,
                                                @Parameter(in = ParameterIn.HEADER, description = "", required = true, schema = @Schema()) @RequestHeader(value = X_VUM_BERICHT_VERSIE, required = true) String xVUMBerichtVersie,
                                                @Pattern(regexp="^\\d{20}$") @Parameter(in = ParameterIn.HEADER, description = "", required = true, schema = @Schema()) @RequestHeader(value = X_VUM_FROM_PARTY, required = true) String xVUMFromParty,
                                                @Pattern(regexp="^\\d{20}$") @Parameter(in = ParameterIn.HEADER, description = "", required = true, schema = @Schema()) @RequestHeader(value = X_VUM_TO_PARTY, required = true) String xVUMToParty,
                                                @Parameter(in = ParameterIn.HEADER, description = "", required = true, schema = @Schema()) @RequestHeader(value = X_VUM_SUWIPARTY, required = true) Boolean xVUMSUWIparty,
                                                @Parameter(in = ParameterIn.HEADER, description = "", required = true, schema = @Schema()) @RequestHeader(value = X_FORWARDED_FOR, required = true) String xForwardedFor,
                                                @Pattern(regexp="^\\d{20}$") @Parameter(in = ParameterIn.HEADER, description = "", schema = @Schema()) @RequestHeader(value = X_VUM_VIA_PARTY, required = false) String xVUMViaParty) {
        log.info("Aanvraag detailvacature van ID: " + idVacature + " door OIN: " + xVUMFromParty + " aan OIN:" + xVUMToParty);
            	
        validateXForwardedForHeader(xForwardedFor);
        
        Optional<Vacature> vacatureOptional = vumService.findById(idVacature, xVUMToParty);
        if (vacatureOptional.isPresent()) {
            elkService.handleRequest(
                    vacatureOptional.get(),
                    xVUMToParty,
                    xVUMFromParty,
                    "GET /vacatures/{idVacature}",
                    "Vraag volledige vacature op bij opgegeven idVacature",
                    "/vacatures/" + idVacature
            );
            log.info("Succesvolle aanvraag detailprofiel van ID: " + idVacature + " door OIN: " + xVUMFromParty + " aan OIN:" + xVUMToParty);

            HttpHeaders headers = new HttpHeaders();
            headers.set(X_VUM_BERICHT_VERSIE, "1.0.0");
            headers.set(X_VUM_FROM_PARTY, xVUMToParty);
            if (!"".equals(xVUMViaParty)) {
            	headers.set(X_VUM_VIA_PARTY, xVUMViaParty); //ViaParty is gelijk aan bemiddelaar provider uit request
            }
            headers.set(X_VUM_TO_PARTY, xVUMFromParty); //ToParty is gelijk aan bemiddelaar uit request
            return new ResponseEntity<>(vacatureOptional.get(), headers, HttpStatus.OK);
        } else {
            log.info("Mislukte aanvraag detailprofiel van ID: " + idVacature + " door OIN: " + xVUMFromParty + " aan OIN:" + xVUMToParty);
            elkService.handleRequest(
                    new VacatureNotFoundException("ID niet gevonden"),
                    xVUMToParty,
                    xVUMFromParty,
                    "GET /vacatures/{idVacature}",
                    "Vraag volledige vacature op bij opgegeven idVacature",
                    "/vacatures/" + idVacature
            );
            throw new VacatureNotFoundException("ID niet gevonden");
        }

    }

	/**
     * POST /vacatures/matches : Zoekopdracht voor Matching Vacature
     * Zoekopdracht om matches voor Vacature op te vragen
     *
     * @param xVUMBerichtVersie (required)
     * @param xVUMFromParty     (required)
     * @param xVUMToParty       (required)
     * @param xVUMSUWIparty     (required)
     * @param matchesRequest    (required)
     * @param xVUMViaParty      (optional)
     * @return OK (status code 200)
     * or Bad request (status code 400)
     * or not authorized (status code 401)
     * or Too Many Requests (status code 429)
     * or Internal Server Error (status code 500)
     * or Service Unavailable (status code 503)
     */
    @Operation(summary = "Zoekopdracht voor Vacatures", description = "Zoekopdracht om Vacature matches op te vragen", tags = {})
    @ApiResponses(value = {
            @ApiResponse(responseCode = "200", description = "OK", content = @Content(mediaType = "application/json", schema = @Schema(implementation = InlineResponse200.class))),
            @ApiResponse(responseCode = "400", description = "Bad request", content = @Content(mediaType = "application/json", schema = @Schema(implementation = Error.class))),
            @ApiResponse(responseCode = "401", description = "not authorized"),
            @ApiResponse(responseCode = "429", description = "Too Many Requests", content = @Content(mediaType = "application/json", schema = @Schema(implementation = Error.class))),
            @ApiResponse(responseCode = "500", description = "Internal Server Error", content = @Content(mediaType = "application/json", schema = @Schema(implementation = Error.class))),
            @ApiResponse(responseCode = "503", description = "Service Unavailable", content = @Content(mediaType = "application/json", schema = @Schema(implementation = Error.class)))})
    @PostMapping(
            value = "/vacatures/matches",
            produces = {"application/json"},
            consumes = {"application/json"}
    )
    public ResponseEntity<InlineResponse200> matchesVacatures(@Parameter(in = ParameterIn.HEADER, description = "", required = true, schema = @Schema()) @RequestHeader(value = X_VUM_BERICHT_VERSIE, required = true) String xVUMBerichtVersie,
    		                                                  @Pattern(regexp="^\\d{20}$") @Parameter(in = ParameterIn.HEADER, description = "", required = true, schema = @Schema()) @RequestHeader(value = X_VUM_FROM_PARTY, required = true) String xVUMFromParty,
    		                                                  @Pattern(regexp="^\\d{20}$") @Parameter(in = ParameterIn.HEADER, description = "", required = true, schema = @Schema()) @RequestHeader(value = X_VUM_TO_PARTY, required = true) String xVUMToParty,
    														  @Parameter(in = ParameterIn.HEADER, description = "", required = true, schema = @Schema()) @RequestHeader(value = X_VUM_SUWIPARTY, required = true) Boolean xVUMSUWIparty,
                                                              @Parameter(in = ParameterIn.DEFAULT, description = "", required = true, schema = @Schema()) @Valid @RequestBody VacatureMatchesRequest matchesRequest,
                                                              @Parameter(in = ParameterIn.HEADER, description = "", required = true, schema = @Schema()) @RequestHeader(value = X_FORWARDED_FOR, required = true) String xForwardedFor,
                                                              @Pattern(regexp="^\\d{20}$") @Parameter(in = ParameterIn.HEADER, description = "", schema = @Schema()) @RequestHeader(value = X_VUM_VIA_PARTY, required = false) String xVUMViaParty) {

        log.info("Aanvraag voor matching vacatures door OIN: " + xVUMFromParty + " aan OIN:" + xVUMToParty);
        elkService.handleRequest(
                matchesRequest,
                xVUMToParty,
                xVUMFromParty,
                "POST /vacatures/matches",
                "Zoekopdracht voor Matching Vacature",
                "/vacatures/matches"
        );
        ImmutablePair<Boolean, VacatureMatchingProfielen> matches = vumService.match(matchesRequest, xVUMToParty);
        log.info("Succesvolle aanvraag voor matchingvacatures door OIN: " + xVUMFromParty + " aan OIN:" + xVUMToParty);
        
        validateXForwardedForHeader(xForwardedFor);
        
        elkService.handleRequest(
                matches,
                xVUMToParty,
                xVUMFromParty,
                "POST /vacatures/matches",
                "Zoekopdracht voor Matching Vacature",
                "/vacatures/matches"
        );

        HttpHeaders headers = new HttpHeaders();
        headers.set(X_VUM_BERICHT_VERSIE, "1.0.0");
        headers.set(X_VUM_FROM_PARTY, xVUMToParty);
        if (!"".equals(xVUMViaParty)) {
        	headers.set(X_VUM_VIA_PARTY, xVUMViaParty); //ViaParty is gelijk aan bemiddelaar provider uit request
        }
        headers.set(X_VUM_TO_PARTY, xVUMFromParty); //ToParty is gelijk aan bemiddelaar uit request
        return new ResponseEntity<>(new InlineResponse200(matches.getLeft(), matches.getRight()), headers, HttpStatus.OK);
    }
    
    /**
     * Indien xForwardedFor geen VUM provider OIN gooi exceptie.
     * Gebruik de VUM provider OIN zonder voorloop nullen
     * 
     * @param xForwardedFor
     */
    private void validateXForwardedForHeader(String xForwardedFor) {
    	String vumProviderOinTrimmed = config.getVumProviderOin().replaceFirst("^0+(?!$)", "");
    	if (!xForwardedFor.contains(vumProviderOinTrimmed)) {
        	log.info(X_FORWARDED_FOR + "='"+ xForwardedFor + "'");
            throw new MismatchCertWithOinVumProviderException(); 
        }		
	}

}

